local GridFrame = Grid:GetModule("GridFrame")

GridTooltip = GridFrame:NewModule("GridTooltip")

GridTooltip.defaultDB = {
}



function GridTooltip.SetIndicator(frame, indicator, color, text, value, maxValue, texture, start, duration, stack)
	
	if texture and indicator == "icon" then
        if frame.unit and UnitExists(frame.unit)then
            frame.ToolTip = nil
            local i = 1
            local name, rank, icon, count, buffType, duration, expirationTime, source, isStealable, _, id = UnitDebuff(frame.unit, i)
            while name do 
                if icon == texture then
                    frame.ToolTip = i
                    break
                end
                i = i + 1
                name, rank, icon, count, buffType, duration, expirationTime, source, isStealable, _, id  = UnitDebuff(frame.unit, i)
            end
        end
	end
end

function GridTooltip.ClearIndicator(frame, indicator)   
    if indicator == "icon" then
        frame.ToolTip = nil
    end
end

function GridTooltip.CreateFrames(gridFrameObj, frame)
    local f = frame
    frame.IconBG:SetScript("OnEnter", GridTooltip.OnEnter)
    frame.IconBG:SetScript("OnLeave", GridTooltip.OnLeave)
    frame.IconBG.frame = frame --oh god!
end

function GridTooltip.OnEnter(iconFrame)
    local frame = iconFrame.frame
    if not frame.ToolTip then return end
    
    local unitid = frame.unit
    if not unitid then return end
    
    GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
    if type(frame.ToolTip) == "string" then
        GameTooltip:SetText( frame.ToolTip ) --not used yet
    elseif frame.ToolTip then
        GameTooltip:SetUnitDebuff(unitid, frame.ToolTip)
    end
    GameTooltip:Show()
end

function GridTooltip.OnLeave(iconFrame)
    GameTooltip:Hide()
end

function GridTooltip:OnInitialize()
   if not self.db then
		self.db = Grid.db:RegisterNamespace(self.moduleName, { profile = self.defaultDB or { } })
	end
    
    --hook the hell out of GridFrame :-)
    hooksecurefunc(GridFrame, "InitializeFrame", GridTooltip.CreateFrames)
    hooksecurefunc(GridFrame.prototype, "SetIndicator", GridTooltip.SetIndicator)
    hooksecurefunc(GridFrame.prototype, "ClearIndicator", GridTooltip.ClearIndicator)
end

function GridTooltip:OnEnable()
end

function GridTooltip:OnDisable()
end

function GridTooltip:Reset(frame)
end